/*
 * Copyright 2012-2013 Q Ethan McCallum, ExMachinaTech.net.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package net.exmachinatech.charcuterie.tools;

/**
 * similar to a builtin Integer object, but with the ability
 * to increment/decrement like a scalar number.
 *
 * TODO: this concept sounds very familiar; I recall there's
 * something similar in an Apache toolkit somewhere.  May as
 * well find that version and use it, instead of this custom
 * implementation.
 */
public class NumberHolder {

	public NumberHolder(){
		this( 0 ) ;
	}

	public NumberHolder( final int initialValue ){
		_value = initialValue ;
	}

	public void increment(){
		++_value ;
	}

	public void decrement(){
		--_value ;
	}

	public int getValue(){
		return( _value ) ;
	}

	private int _value ;

} // NumberHolder
