/*
 * Copyright 2012-2013 Q Ethan McCallum, ExMachinaTech.net.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package net.exmachinatech.charcuterie.tools;

import java.io.Reader;
import java.io.StringReader;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.xml.sax.InputSource;

public class XMLTools {

	public static Document stringToXML( final String xmlText ) throws Exception {

		final Reader xml = new StringReader( xmlText ) ;

		final DocumentBuilderFactory domFactory = DocumentBuilderFactory.newInstance();
	    domFactory.setNamespaceAware(true );
	    // don't load the DTD, especially since we don't have it
	    domFactory.setFeature( "http://apache.org/xml/features/nonvalidating/load-external-dtd" , false ) ;

	    /*
	    TODO: for some reason, using any kind of InputStream instead of a
	    reader yields XML parsing errors:
	     	org.xml.sax.SAXParseException: Content is not allowed in prolog.
	    	org.xml.sax.SAXParseException: Content is not allowed in trailing section.
	     Using a Reader, however, works just fine.  The Text object for the inputValue
	     was built using a Reader so in theory it shouldn't have any binary oddities ...

	     */

	    final DocumentBuilder builder = domFactory.newDocumentBuilder();

	    final Document result = builder.parse( new InputSource( xml ) ) ;

	    return( result ) ;

	}

} // XMLTools
